package io.gitlab.jfronny.libjf.unsafe;

import io.gitlab.jfronny.commons.log.Logger;
import io.gitlab.jfronny.commons.serialize.gson.api.GsonHolder;
import io.gitlab.jfronny.libjf.LibJf;
import io.gitlab.jfronny.libjf.gson.HiddenAnnotationExclusionStrategy;
import net.fabricmc.loader.api.LanguageAdapter;

public class  JfLanguageAdapter implements LanguageAdapter {
    @Override
    public native <T> T create(net.fabricmc.loader.api.ModContainer mod, String value, Class<T> type);

    static {
        Logger.registerFactory(FLLogger::new); // Reset in LibJf entrypoint
        HiddenAnnotationExclusionStrategy.register();
        GsonHolder.register();
        DynamicEntry.execute("libjf:preEarly", UltraEarlyInit.class, s -> s.instance().init());
        DynamicEntry.execute("libjf:early", UltraEarlyInit.class, s -> s.instance().init());
        LibJf.LOGGER.info("LibJF unsafe init completed");
    }
}
